import React from 'react';
import { ReactJSXElement } from '_@emotion_react@11.4.1@@emotion/react/types/jsx-namespace';
import './index.less';
export declare const maxWidgetLength = 20;
export declare type LayoutItem = {
    w: number;
    h: number;
    x: number;
    y: number;
    i: string;
    minW: number;
    maxW: number;
    minH: number;
    maxH: number;
};
export declare type LayoutsIf = LayoutItem[];
export interface widgetIF {
    name: string;
    description: string;
    tags: string[];
    component: ReactJSXElement;
    configComponent: ReactJSXElement;
    maxLength: number;
    snapShot: ImageBitmapSource;
    icon: ReactJSXElement;
    iconBackground: string;
    size: {
        defaultWidth: number;
        defaultHeight: number;
        maxWidth: number;
        maxHeight: number;
        minWidth: number;
        minHeight: number;
    };
    [key: string]: any;
}
interface widgetsIF {
    [key: string]: widgetIF;
}
export interface Dashboard {
    id: string;
    widgets: widgetsIF;
    editMode?: boolean;
    exitEditCallback?: Function;
    initialLayout?: LayoutItem[];
    widgetWrapClassName?: string;
    widgetWrapStyle?: React.CSSProperties;
    currentLayout?: LayoutItem[];
    onLayoutChange: (layout: LayoutItem[]) => void;
    onReset: (dirtyCurrentLayout: LayoutItem[], currentLayout: LayoutItem) => void;
    onRemoveWidget: (widget: widgetIF, dirtyCurrentLayout: LayoutItem[], currentLayout: LayoutItem[]) => void;
    onAddWidget: (widget: widgetIF, dirtyCurrentLayout: LayoutItem[], currentLayout: LayoutItem[]) => void;
    onReload: (currentLayout: LayoutItem[]) => void;
    onCancelEdit: (dirtyCurrentLayout: LayoutItem[], currentLayout: LayoutItem) => void;
    onEdit: (currentLayout: LayoutItem[]) => void;
    onSave: (currentLayout: LayoutItem[]) => void;
    onRevert: (dirtyCurrentLayout: LayoutItem[], currentLayout: LayoutItem) => void;
    [key: string]: any;
}
declare const Dashboard: React.ForwardRefExoticComponent<Pick<Dashboard, string | number> & React.RefAttributes<unknown>>;
export default Dashboard;
